/*
 * file: Classify.java
 *
 * Last edited: Ryan Irwin
 *
 */


// import necessary java libraries
//
import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.net.*;
import java.applet.*;

/**
*
* Classify is the main driver program that extend JApplet and is the 
* class called when the applet is loaded, which inturn initialize all
* other objects and components need to run the applet
*
* hierarchy: JApplet->Classify
*
*/
public class Classify extends JApplet
{

	static final long serialVersionUID = 0;
    // *********************************************************************
    //
    // declare global variables and components
    //
    // *********************************************************************
    
    // declare global variables
    //
    Vector<URL> url_vec_d = new Vector<URL>(5, 1);
    
    // point type
    //
    public static final int PTYPE_INPUT = 1;
    public static final int PTYPE_OUTPUT = 2;
    public static final int PTYPE_SUPPORT_VECTOR = 3;
    public static final int PTYPE_OUTPUT_LARGE = 4;
    public static final int PTYPE_LINE = 5;
    public static final double X_MAX = 2.0;
    public static final double Y_MAX = 2.0;
    
    
    // declare components
    //
    static MainMenu main_menu_d;
    static ProcessBox pro_box_d = new ProcessBox();
    static DataPoints input_points_d = new DataPoints();
    static InputPanel input_panel_d = new InputPanel(input_points_d);
    static OutputPanel output_panel_d = new OutputPanel();
    static Vector<Algorithm> algo_vec_d = new Vector<Algorithm>();
    static int algo_index_d = -1;
    
    static int algo_index_svm_d = -1;
    static int algo_index_pcaci_d = -1;
    static int algo_index_pca2_d = -1;
    static int algo_index_rvm_d = -1;
    static int algo_index_ldapca1_d = -1;
    //   static int algo_index_ldapca2_d = -1;
    static int algo_index_pf_d = -1;
    static int algo_index_kf_d = -1;
    static int algo_index_ukf_d = -1;
    static int algo_index_lp_d = -1;
    
    // Phil T. - Added 
    //
    static int algo_index_ldaci_d = -1;
    static int algo_index_lda2_d = -1;
    static int algo_index_ed_d = -1;
    static int algo_index_nn_d = -1;
    static int algo_index_kmeans_d = -1;
    static int algo_index_lbg_d = -1;

    // Tao - Added
    //
    static int algo_index_hlda_d = -1;
 
    // *********************************************************************
    //
    // declare non-static variables and components
    //
    // *********************************************************************
    
    JPanel content_pane_d = new JPanel();
    int width_d = 0; // width of the canvas
    int height_d = 0; // height of the canvas
    
    int zero_x_d = 0; // zero position on x axis
    int zero_y_d = 0; // zero position on y axis
    
    // *********************************************************************
    //
    // declare class constructors
    //
    // *********************************************************************
    
    /**
     * Initializes variables
     */
    public void preInit()
    {
	pro_box_d = new ProcessBox();
	input_points_d = new DataPoints();
	input_panel_d = new InputPanel(input_points_d);
	output_panel_d = new OutputPanel();
	algo_vec_d = new Vector<Algorithm>();
	algo_index_d = -1;

	algo_index_svm_d = -1;
	algo_index_pcaci_d = -1;
	algo_index_pca2_d = -1;
	algo_index_rvm_d = -1;
	algo_index_ldapca1_d = -1;
	algo_index_pf_d = -1;
	algo_index_kf_d = -1;
	algo_index_ukf_d = -1;
	algo_index_lp_d = -1;
	// Tao
	algo_index_hlda_d = -1;
	

	// set the sizes of the input and output panels and process box
	//
	input_panel_d.setSize(new Dimension(30, 40));
	input_panel_d.setPreferredSize(new Dimension(30, 40));
	input_panel_d.setMinimumSize(new Dimension(30, 40));
	input_panel_d.setMaximumSize(new Dimension(30, 40));

	output_panel_d.setSize(new Dimension(30, 40));
	output_panel_d.setPreferredSize(new Dimension(30, 40));
	output_panel_d.setMinimumSize(new Dimension(30, 40));
	output_panel_d.setMaximumSize(new Dimension(30, 40));

	pro_box_d.setSize(new Dimension(50, 80));
	pro_box_d.setPreferredSize(new Dimension(50, 80));
	pro_box_d.setMinimumSize(new Dimension(50, 80));
	pro_box_d.setMaximumSize(new Dimension(50, 80));

	getRootPane().putClientProperty(
					"defeatSystemEventQueueCheck",
					Boolean.TRUE);
    }

    // *********************************************************************
    //
    // declare class methods
    //
    // *********************************************************************

      /**
       * main method, the entrance of the program
       * 
       * @param   args command line arguments
       */
      public static void main(String[] args)
      {
	  
	  try
	  {
	      // set the look and feel
	      //
	      //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	  } 
	  catch (Exception e)
	      {}
	  
	  Classify frame = new Classify();
	  frame.setSize(new Dimension(480, 520));
	  frame.init();
	  //frame.pack();
	  
	  //Center the window
	  //
	  Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
	  Dimension frameSize = frame.getSize();
	  if (frameSize.height > screenSize.height)
	      frameSize.height = screenSize.height;
	  if (frameSize.width > screenSize.width)
	      frameSize.width = screenSize.width;
	  frame.setLocation(
			    (screenSize.width - frameSize.width) / 2,
			    (screenSize.height - frameSize.height) / 2);
	  frame.setVisible(true);
	  
      }
    
    /**
     * this method is called when the applet is started
     *
     */
    public void init()
  {

      super.init();

      preInit();

      // declare components to read the help files
      //
      try
      {
	  URL url;
	  url = new URL(getCodeBase() + "doc/help_release.txt");
	  url_vec_d.addElement(url);
	  url = new URL(getCodeBase() + "doc/help_info_support.txt");
	  url_vec_d.addElement(url);
	  url = new URL(getCodeBase() + "doc/help_overview.txt");
	  url_vec_d.addElement(url);
	  url = new 
URL("http://www.isip.piconepress.com/projects/speech/software/demonstrations/applets/util/pattern_recognition/tutorials/");
	  url_vec_d.addElement(url);
	  url = new URL(getCodeBase() + "doc/help_plugins.txt");
	  url_vec_d.addElement(url);
      } 

      catch (MalformedURLException me)
	  {System.out.println("ME");}

      // get the applet context
      //
      AppletContext context = getAppletContext();

      // initialize the menu bar object
      //
      main_menu_d = new MainMenu(url_vec_d, context);
      //main_menu_d = new MainMenu(null, null);

      this.setContentPane(content_pane_d);
      GridBagLayout gridbag = new GridBagLayout();
      content_pane_d.setLayout(gridbag);
      content_pane_d.setBorder(
	      BorderFactory.createCompoundBorder(
		   BorderFactory.createRaisedBevelBorder(),
		   BorderFactory.createLoweredBevelBorder()));

      main_menu_d.constrain(
			    content_pane_d,
			    main_menu_d,
			    0,
			    0,
			    GridBagConstraints.REMAINDER,
			    1,
			    GridBagConstraints.BOTH,
			    GridBagConstraints.NORTHWEST,
			    1,
			    0.1,
			    2,
			    2,
			    2,
			    2);
      input_panel_d.constrain(
			      content_pane_d,
			      input_panel_d,
			      0,
			      1,
			      1,
			      1,
			      GridBagConstraints.BOTH,
			      GridBagConstraints.NORTHWEST,
			      1,
			      1,
			      0,
			      0,
			      0,
			      0);
      output_panel_d.constrain(
			       content_pane_d,
			       output_panel_d,
			       0,
			       2,
			       1,
			       1,
			       GridBagConstraints.BOTH,
			       GridBagConstraints.NORTHWEST,
			       1,
			       1,
			       0,
			       0,
			       0,
			       0);
      pro_box_d.constrain(
			  content_pane_d,
			  pro_box_d,
			  1,
			  1,
			  GridBagConstraints.REMAINDER,
			  GridBagConstraints.REMAINDER,
			  GridBagConstraints.BOTH,
			  GridBagConstraints.NORTHWEST,
			  1,
			  1,
			  0,
			  0,
			  0,
			  0);

      // add the components in the respective panels
      //
      //pro_bar_d.add_components();
      pro_box_d.add_components();
      main_menu_d.add_components();
      input_panel_d.add_components();
      output_panel_d.add_components();
      
      // add algorithms
      //
      AlgorithmSVM algo_svm = new AlgorithmSVM();
      algo_vec_d.add(algo_svm);
      algo_index_svm_d = 0;
      
      AlgorithmPCA algo_pca = new AlgorithmPCA();
      algo_vec_d.add(algo_pca);
      algo_index_pcaci_d = 1;

      AlgorithmRVM algo_rvm = new AlgorithmRVM();
      algo_vec_d.add(algo_rvm);
      algo_index_rvm_d = 2;

      AlgorithmPCA2 algo_pca2 = new AlgorithmPCA2();
      algo_vec_d.add(algo_pca2);
      algo_index_pca2_d = 3;
      
      // Added By Phil Trasatti - 7/10/03
      AlgorithmLDA algo_lda = new AlgorithmLDA();
      algo_vec_d.add(algo_lda);
      algo_index_ldaci_d = 4;

      // Added By Phil Trasatti - 7/10/03
      AlgorithmLDA2 algo_lda2 = new AlgorithmLDA2();
      algo_vec_d.add(algo_lda2);
      algo_index_lda2_d = 5;
      
      // Added By Phil Trasatti - 7/10/03
      AlgorithmLBG algo_lbg = new AlgorithmLBG();
      algo_vec_d.add(algo_lbg);
      algo_index_lbg_d = 6;
      
      // Added By Phil Trasatti - 7/10/03
      AlgorithmKMeans algo_kmeans = new AlgorithmKMeans();
      algo_vec_d.add(algo_kmeans);
      algo_index_kmeans_d = 7;
      
      // Added By Phil Trasatti - 7/10/03
      AlgorithmNN algo_nn = new AlgorithmNN();
      algo_vec_d.add(algo_nn);
      algo_index_nn_d = 8;
      
      // Added By Phil Trasatti - 7/10/03
      AlgorithmED algo_ed = new AlgorithmED();
      algo_vec_d.add(algo_ed);
      algo_index_ed_d = 9;
      
      // Added By Jun-Won Suh - 27/10/04
      AlgorithmLDAPCA algo_ldapca = new AlgorithmLDAPCA();
      algo_vec_d.add(algo_ldapca);
      algo_index_ldapca1_d = 10;
      
      // Added By Jun-Won Suh - 27/10/04
      AlgorithmLP algo_lp = new AlgorithmLP();
      algo_vec_d.add(algo_lp);
      algo_index_lp_d = 11;
      
      // Added By Ryan Irwin - 07/20/05
      //
      AlgorithmKF algo_kf = new AlgorithmKF();
      algo_vec_d.add(algo_kf);
      algo_index_kf_d = 12;
           
      // Added By Ryan Irwin - 07/20/05
      //
      AlgorithmPF algo_pf = new AlgorithmPF();
      algo_vec_d.add(algo_pf);
      algo_index_pf_d = 13;

      // Added By Ryan Irwin - 11/15/05
      //
      AlgorithmUKF algo_ukf = new AlgorithmUKF();
      algo_vec_d.add(algo_ukf);
      algo_index_ukf_d = 14;

      // Added By Tao Ma - 01/20/08
      //
      AlgorithmHLDA algo_hlda = new AlgorithmHLDA();
      algo_vec_d.add(algo_hlda);
      algo_index_hlda_d = 15;
 
      // set the default algo
      algo_index_d = algo_index_ukf_d;
      
  }
    
    /**
     * determines the dimensions of the selection area
     *
     */
    public void DetermineDimensions()
    {
	
	Dimension dimen = this.getSize();
	width_d = dimen.width;
	height_d = dimen.height;
	
	// divide by 2
	//
	zero_x_d = width_d >> 1;
	zero_y_d = height_d >> 1;
    }

    /**
     * determine the current algorithm and returns an object for it
     *
     * @return Object of current algorithm
     *
     */
    static public Object getCurrAlgo()
    {
	// Debug
	//
	//	System.out.println("Classify : getCurrAlgo()");
	
	//algo_index_d = 0 ;
	return algo_vec_d.get(algo_index_d);
    }
    
    /**
     * determine the dimensions of the selection area
     *
     * @param    algo_a The algorithm to he initialized
     * @return   true
     *
     */
    static public boolean initializeAlgo(Algorithm algo_a)
    {
	
	// initialize i/o compoents
	//
	algo_a.setDataPoints(input_points_d);
	//algo_a.setInputPanel(input_panel_d);
	algo_a.setOutputPanel(output_panel_d);
	algo_a.setProcessBox(pro_box_d);
	
	// init the algorithm
	//
	return true;
	
    }

    /**
     * determine the dimensions of the selection area
     * actually this draws a line of width 3 pixels in either directions
     * in way, this draws a + sign..
     * 3 pixels because, -3 /2 and + 3 / 2 on either side.
     *
     * @param   device_a  graphics object used
     * @param   point_a   point which will be displayed
     * @param   type_a    integer describing type
     * @param   color_a   color of the point
     *
     * @return  true
     *
     */
  static public boolean drawPoint(
				  Graphics device_a,
				  Point point_a,
				  int type_a,
				  Color color_a)
    {
	int X, Y;

	Color curr_color = device_a.getColor();
	device_a.setColor(color_a);
	
	X = (int)point_a.x;
	Y = (int)point_a.y;
	
	// draw different point
	//
	switch (type_a)
	{
	case PTYPE_INPUT :
	    device_a.drawLine(X - 3 / 2, Y, X + 3 / 2, Y);
	    device_a.drawLine(X, Y - 3 / 2, X, Y + 3 / 2);
	    device_a.setColor(curr_color);
	    break;
	    
	case PTYPE_OUTPUT :
	    break;
	    
	case PTYPE_SUPPORT_VECTOR :
	    device_a.setColor(color_a);
	    device_a.drawOval(X - 5 / 2, Y - 5 / 2, 5, 5);
	    device_a.setColor(curr_color);
	    break;
	    
	case PTYPE_OUTPUT_LARGE :
	    device_a.setColor(color_a);
	    device_a.fillOval(X - 5 / 2, Y - 5 / 2, 5, 5);
	    device_a.setColor(curr_color);
	    break;
	    
	default :
	    break;
	}
	
	// reset the color
	//
	device_a.setColor(curr_color);
	
	// init the algorithm
	//
	return true;
    }

    /**
     * determine the dimensions of the selection area
     *
     * @param   device_a  graphics object used
     * @param   points_a  points which will be displayed
     * @param   type_a    integer describing type
     * @param   color_a   color of the point
     *
     * @return  true
     *
     */
    static public boolean drawPoints(
				     Graphics device_a,
				     Vector points_a,
				     int type_a,
				     Color color_a)
    {


	// put the code here for drawing lines..
	if (type_a == PTYPE_LINE)
	{
	    putLines(device_a, points_a, type_a, color_a);
	}
	
	if (type_a != PTYPE_LINE)
	{
	    for (int i = 0; i < points_a.size(); i++)
	    {   
		drawPoint(device_a, (Point)points_a.get(i), type_a, color_a);
	    }
	}
	// init the algorithm
	//
	return true;
    }
    
    /**
     * Method : putlines
     * Method to draw a line between a series of points. The lines sequentially
     * connect the first point to the second then the second to the third,
     * til the last point.
     *
     * @param   device_a  graphics object used
     * @param   points_a  points which will be displayed
     * @param   type_a    integer describing type
     * @param   color_a   color of the point
     *
     * @return  true
     */
    static public boolean putLines (
				    Graphics device_a,
				    Vector points_a, 
				    int type_a,
				    Color color_a)
    {
	
	for (int i = 0; i < points_a.size() - 1; i++)
	{
	    putLine(device_a, (Point)points_a.get(i), (Point)points_a.get(i + 1), color_a);
	}
	return true;
    }
    
    /**
     * Method to draw a line between two points. The method is called
     * for putting a single line at a time by method putlines which is used 
     * to draw lines between a series of points
     *
     * @param   device_a  graphics object used
     * @param   first_pt_a Line begining point
     * @param   second_pt_a Line ending point
     * @param   color_a The color of the line
     *
     * @return  boolean
     */
    static public boolean putLine (
				   Graphics device_a,
				   Point first_pt_a, 
				   Point second_pt_a,
				   Color color_a)
    {
	Color curr_color = device_a.getColor();
	device_a.setColor(color_a);
	
	int X1 = 0;
	int X2 = 0;
	int Y1 = 0;
	int Y2 = 0;
	
	X1 = (int) first_pt_a.x;
	X2 = (int) second_pt_a.x;
	Y1 = (int) first_pt_a.y;
	Y2 = (int) second_pt_a.y;
	
	// draw line between two consecutive points
	//
	device_a.drawLine(X1, Y1, X2, Y2);
	device_a.drawLine(X1 - 1 / 2, Y1, X2 - 1 / 2, Y2);
	device_a.drawLine(X1 + 1 / 2, Y1, X2 + 1 / 2, Y2);
	device_a.setColor(curr_color);
	
	return true;
    } 

}
