/**
 * file: DisplayScale.java
 *
 * last edited: Ryan Irwin
 *
 */




/**
 *
 * class holds the input DataPoints classes that are to be classified as well
 * as the classification algorithms needed to compute the decision regions
 *
 */
class DisplayScale 
{

    // *********************************************************************
    //
    // declare global variables and components
    //
    // *********************************************************************
    
    // declare class members
    //
    public double xmax = 0.0;
    public double xmin = 0.0;
    public double ymax = 0.0;
    public double ymin = 0.0;
    
    // *********************************************************************
    //
    // declare class constructors
    //
    // *********************************************************************

    /**
     * constructor initializes the x and y co-odinates
     *
     */
    DisplayScale () 
    {}
    
    /**
     * DisplayScale constructor with parameters
     *
     * @param   xmax value of maximum on x-axis
     * @param   xmin value of minimum on x-axis
     * @param   ymax value of maximum on y-axis
     * @param   ymin value of minimum on y-axis
     * 
     */
     DisplayScale (double xmax, double xmin, double ymax, double ymin)
    {
	this.xmax = MathUtil.SetDecimal(xmax, 2);
	this.xmin = MathUtil.SetDecimal(xmin, 2);
	this.ymax = MathUtil.SetDecimal(ymax, 2);
	this.ymin = MathUtil.SetDecimal(ymin, 2);
    }
    
    /**
     * Converts object to a String
     *
     * @return   string of the display scale axis
     *
     */
    public String toString() 
    { 
	
	return "[" + xmin + "<= x <=" + xmax + "  " 
	    + ymin + "<= y <= " + ymax + "]";
    }
}

