/**
 * file: ProgressBar.java
 *
 */

// import necessary java libraries
//
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;

//These imports are not needed - Phil T. 6-23-03
//import java.awt.event.*;

/**
 * class: ProgressBar
 *
 * ProgressBar inplements the text area to the right of the applet that 
 * acts as a process description for the various algorithms being used
 *
 * hierarchy: JPanel->SubPanel->ProgressBar
 *
 */
class ProgressBar extends SubPanel 
{
	static final long serialVersionUID = 0;
    // *********************************************************************
    //
    // declare global variables and components
    //
    // *********************************************************************

    // declare components
    //
    JProgressBar progressBar;

    // *********************************************************************
    //
    // declare class constructors
    //
    // *********************************************************************

    /**   
     * method: ProcessBox
     *
     * @param   none
     * @return  none
     *
     * constructor initializes the text area and scroll bar objects
     *
     */
    ProgressBar() 
    {

	// set the border for the panel
	//
	Border lineBorder = BorderFactory.createLineBorder(Color.black);
	setBorder(lineBorder);

	// declare the progress bar components
	//
	progressBar = new JProgressBar();
        progressBar.setValue(0);
        progressBar.setStringPainted(true);
    }

    // *********************************************************************
    //
    // declare class methods
    //
    // *********************************************************************

    /**    
     * method: add_components
     *
     * @param   none
     * @return  none
     *
     * add components to the input panel
     *
     */
    public void add_components() 
    {
	
	constrain(this, 
		  progressBar, 
		  0, 
		  0, 
		  GridBagConstraints.REMAINDER, 
		  GridBagConstraints.REMAINDER, 
		  GridBagConstraints.BOTH,
		  GridBagConstraints.NORTHWEST, 
		  1, 
		  1, 
		  0, 
		  0, 
		  0, 
		  0);
    }
}
