# file: Makefile
#

# define include and library paths
#
COMMON=./common
SRCHOME=./src
JARPATH=./jar
JARFILE=pattern_recognition.jar

# compile the java classes
#
echo "> compiling the source code ..."
#javac -sourcepath $SRCHOME $SRCHOME/*.java 
javac $SRCHOME/*.java

echo "> javadoc compiling ..."
javadoc $SRCHOME/*.java -d $COMMON/doc

# compress and archive the java classes
#
echo "> compressing and archiving the classes ..."
jar cf $JARFILE -C $SRCHOME .

# move the jar file to the appropriate path
#
echo "> dumping the archive file ..."
mv $JARFILE $JARPATH

#
# end of file
